#include <avr/io.h>
#include <avr/interrupt.h> 
#include <string.h>
#define BYTE  unsigned char

unsigned char rxd_data=0x00; 
unsigned char txd_data=0x00; 

/* USART 1 receive interrupt vector */
SIGNAL(USART1_RX_vect)
{ 
	rxd_data = UDR1;
	txd_data = rxd_data;
	UDR1 = txd_data; /* echo back received data */
}
void TXChar(BYTE tx_data)
{
  
  /* wait until transmitter buffer is ready */
	while((UCSR1A&0x20) == 0x00); 
	UDR1 = tx_data; /* send data to transmitter buffer */
}

/*
BYTE strlen( BYTE *str )
{
	BYTE i=0;

	while( *str++ ) i++;
	return i;
}
*/


void PutChar(BYTE *databuf,BYTE num)
{
	BYTE CharCount;
	BYTE i;

	CharCount = num	;
	if( !CharCount ) CharCount = strlen( (char *)databuf );
	for(i=0; i<CharCount; i++){
		TXChar(databuf[i]);
	}
}

int main(void)
{
	cli(); /* disable interrupt */

	/* USART0 initialization */
	UCSR1A = 0x00;
	UCSR1B = 0x98;
	UCSR1C = 0x06;
	UBRR1H = 0x00; /* baud rate 115200 UBRR1=8*/
	UBRR1L = 0x08;

	PutChar((unsigned char *)"Serial Communication OK\r\n", 0);

	sei(); /* enable interrupt */

	while(1);

}
